=== data/Makefile ===
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)

all: knlsb

knlsb:

knllb:

install: install-knlsb

install-knlsb:
	$(INSTALL) -d $(DESTDIR)$(datadir)/micperf/data
	$(INSTALL) -m 644 knlsb/README.txt $(DESTDIR)$(datadir)/micperf/data
	- $(INSTALL) -m 644 knlsb/*.pkl $(DESTDIR)$(datadir)/micperf/data

install-knllb:
	$(INSTALL) -d $(DESTDIR)$(datadir)/micperf/data
	- $(INSTALL) -m 644 knllb/README.txt $(DESTDIR)$(datadir)/micperf/data
	- $(INSTALL) -m 644 knllb/*.pkl $(DESTDIR)$(datadir)/micperf/data

.PHONY: all knc knlsb knllb install install-knc install-knlsb install-knllb
