=== doc/Makefile ===
INSTALL ?= install
VERSION ?= 0.0.0
prefix ?= /usr
datarootdir ?= $(prefix)/share
datadir ?= $(datarootdir)
docdir ?= $(datarootdir)/doc/micperf

all:
	-

install: micperf_users_guide.pdf
	$(INSTALL) -D -m 644 micperf_users_guide.pdf ${DESTDIR}$(docdir)/user_guide.pdf

clean:
	-

.PHONY:  all install install-server clean
