=== ut/Makefile ===
PYTEST ?= py.test
FILTER ?= ''
all: micp_ut

ifeq ($(PROJECT),knllb)
IGNORE_LIST =	micp_kernels_hplinpack_test.py micp_kernels_hpcg_test.py micp_kernels_generic_test.py micp_kernels_test_data.py
IGNORE = $(foreach file,$(IGNORE_LIST),--ignore="micp_ut/$(file)")
endif

micp_ut:
	export PYTHONPATH=$(pytest_installroot_sitepackages):$$PYTHONPATH; \
	export PYTHONPATH=../micp:$$PYTHONPATH; \
	$(PYTEST) -v -s -k $(FILTER) $(IGNORE) --color=no -v --cov-report html --cov-report annotate --cov ../micp ./micp_ut

clean:
	$(MAKE) -C micp_ut clean
	-rm -rf htmlcov
	-rm -rf tmp*
	-rm -rf micp_run_*

.PHONY: micp_ut clean
