=== apps/sysdiag/Makefile ===
# Copyright 2012-2017 Intel Corporation.
# 
# This software is supplied under the terms of a license agreement or
# nondisclosure agreement with Intel Corporation and may not be copied
# or disclosed except in accordance with the terms of that agreement.

TOPDIR ?= ../..

-include $(TOPDIR)/common.mk

SYSDIAG_SRC_DIR = $(TOPDIR)/apps/sysdiag
SYSDIAG_SBIN_DIR ?= $(SBINDIR)
SYSDIAG_MODULE_DIR ?= $(DATAROOTDIR)/$(proj_target)/sysdiag
SYSDIAG_DOC_DIR = $(DOCDIR)/sysdiag

all :
	-

install : dirs
	sed -i -e "s|''#XPPSL_SYSDIAG_INSTALL_DIR#|\"$(abspath $(SYSDIAG_MODULE_DIR))\"|g" $(SYSDIAG_SRC_DIR)/sysdiag
	$(INSTALL_x) $(SYSDIAG_SRC_DIR)/sysdiag $(DESTDIR)/$(SYSDIAG_SBIN_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/__init__.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/sys_diag.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/sys_utils.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_memory.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_pcie.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_power.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(SYSDIAG_SRC_DIR)/diag_system.py $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_r) $(TOPDIR)/LICENSE_close.txt $(DESTDIR)/$(SYSDIAG_DOC_DIR)/LICENSE.txt

test:
	$(MAKE) -C ut sysdiag_ut

dirs :
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_SBIN_DIR)
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_MODULE_DIR)
	$(INSTALL_d) $(DESTDIR)/$(SYSDIAG_DOC_DIR)

clean :
	rm -rf *.pyc
	rm -rf __pycache__
	rm -rf ut/*pyc
	rm -rf ut/__pycache__

.PHONY : all install dirs clean test
