=== changelog ===
zonesort (1.0+xpps-2.2.0.573) artful-xpps; urgency=low

  * The zonesort module CI build.

 -- Intel Corporation <https://supporttickets.intel.com>  Thu, 09 Nov 2017 14:51:07 +0000

zonesort (1.0+xpps-1) unstable; urgency=low

  * Inititial zonesort release for Intel(R) Xeon Phi(TM) processor software.

 -- Adam Lessnau <adam.lessnau@intel.com>  Mon, 30 Oct 2017 12:31:55 +0100
