=== debian/changelog ===
memkind (1.6.0+xpps-2.2.0.573) artful-xpps; urgency=low

  * The memkind source code used by the XPPS release.
  * See ChangeLog for more details.

 -- Intel Corporation <https://supporttickets.intel.com>  Thu, 09 Nov 2017 14:51:06 +0000
