=== control ===
Source: zonesort
Origin: Intel(R) Xeon Phi(TM) processor software
Maintainer: Intel Corporation <https://supporttickets.intel.com>
Section: admin
Priority: optional
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 9)

Package: zonesort
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zone free list sorter
 The zonesort module provides mechanism to change order in a list of free pages kept
 in Linux kernel buddy allocator. The order is changed so to minimize possible
 page collisions later when those pages are served to the application.
 The algorithm assumes that the system has up to 16GB of direct-mapped cache.
