=== rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export MODULE_VERSION = $(shell dpkg-parsechangelog -SVersion)
export KERNEL_SRC = /usr/src/linux-headers-4.13.0-16-generic

%:
	dh $@
